#ifndef _UART2_WRAPPER_H_
#define _UART2_WRAPPER_H_

typedef void (*recv_callback_t)(void *context, unsigned char *data, int count);

int uart_wrapper_send(unsigned char *buff, unsigned int count);
int uart_wrapper_receive(unsigned char *buff, unsigned int count);
void uart_wrapper_stop_task(void);
int uart_wrapper_start_receiving_task(recv_callback_t recv_callback, 
    void *context);
    
#endif
