#include "clprgCons.h"
#include "clprgSt.h"
#include "clplif.h"

#if FXO_MODULE
/*
Word16	CpFilterCoefs[BUTTERCOEFSLEN] = 
{
2759,
0,
-2760,
24795,
32767,
-27254,
};
*/

Word16  CpFilterCoefs[3] =
{
7542,
7542,
-17681
};


extern Word16 speech[];
extern Word16 dialtontcount[ ];

Word16 FlagDetectBusyTone[MAX_CHAN] = {0};
Word16 FlagDetectDialTone[MAX_CHAN] = {0};
Word16 ChanNum;
CALLPROGRESSSTRUCT	Clprg[MAX_CHAN]; 
Word16 InputBuf[FRAMELEN];
Word16 FlagFirstTime = 1;
Word16 check_total_frames[2]={0,0};
uWord32 Threshold =12800 ;

void getToneDet(Word16 i);
extern void dspipcToneIndication(unsigned portNum,unsigned short Tonetype);
extern void confSetToneDetect(UCHAR port, UCHAR toneEnable);
void ToneDetInit(Word16 i)
{
                InitCallProgress(i);

                getToneDet(i);
                 check_total_frames[i]=0;

}

void ToneDetmain(unsigned short Portnum)
{
	
	//Word16 Flag[MAX_CHAN],FrameCnt[MAX_CHAN],i;
	Word16 i;


               ChanNum = (Word16) Portnum;

               for(i = 0;i<80;i++)
                  InputBuf[i] = speech[i]; 


		ESL_CPTDetector(&InputBuf[0]);
               
		//FrameCnt[ChanNum]++;
#if 0//def DEF_CNGDET
		if(Clprg[ChanNum].DetCNG ) {
			printf("Number of frames processed: %d",FrameCnt[ChanNum]);
			printf("\nCNG Tone Detected\n");
			//break;
		}
#endif	
}
void getToneDet(Word16 i)
{
          Clprg[i].DetectDialTone = FlagDetectDialTone[i];
          Clprg[i].DetectBusyTone = FlagDetectBusyTone[i];

}
void setToneDet(Word16 ChNum,Word16 Tone_Type)
{

     if(Tone_Type == 1)   // DIAL
     {
         FlagDetectDialTone[ChNum] = 1;
     } 
     else if(Tone_Type == 2)   // BUSY
         FlagDetectBusyTone[ChNum] = 1;
     else if(Tone_Type == 3)   // RB
         FlagDetectBusyTone[ChNum] = 2;


}

void InitCallProgress(Word16 i )
{
        ClearStruct((char*) &Clprg[i],sizeof(CALLPROGRESSSTRUCT));
        Clprg[ChanNum].MinIpLvl = LVL_43dBm;
}
void ClearStruct (CHAR *p, Word16 l)
{
        Word16 i=0;
        while(l)
        {
                p[i++] = 0;
                l--;
        }
}
Word16 ButterWorth(Word16 *Dl,Word16 *Coefs, Word16 Smpl,Word16 scale)
{
        Word32 Op;


        Op = (Word32)Smpl*Coefs[0] + (Word32)Dl[0]*Coefs[1] ;

        Dl[0] = Smpl;

        Op += (Word32)Dl[2]*Coefs[3] ;
        Op = Op << (1+scale);

        Dl[2] = Round(Op);
        return (Dl[2]);
}
void ESL_CPTDetector( Word16 *SampleBuf)
{
        Word16 i,temp,j;
        uWord32  curr_power,resultpower,sumpower;

         for(i=0;i<80;i++)
          {
          temp=ButterWorth(Clprg[ChanNum].CpDlyLine,CpFilterCoefs,InputBuf[i],0);
           InputBuf[i]=temp;
           }
               //curr_power=power_calc1(&WorkingBuff[0],80);


                sumpower=0;
                for(j=0;j<4;j++)
                {
                   resultpower=0;
               for(i=0;i<20;i++)
               {
              curr_power=(Word32)InputBuf[i+(j*20)]*(Word32)InputBuf[i+(j*20)];
               resultpower=resultpower+curr_power;
               }
               sumpower+=resultpower>>7;
            }
/*
          curr_power=0;
         for(i=0;i<80;i++)
              curr_power=(Word32)WorkingBuff[i]*(Word32)WorkingBuff[i];
*/

          for(i=3;i>=0;i--)
          Clprg[ChanNum].power[i+1]=Clprg[ChanNum].power[i];


                Clprg[ChanNum].power[0]=sumpower;

                 resultpower=0;
                for(i=0;i<5;i++)
             resultpower=resultpower+Clprg[ChanNum].power[i];

                Clprg[ChanNum].resultpower=resultpower;
                //fprintf(output,"%ul \t %ul \n",resultpower,Threshold);

                CpReceiver();

}
void ProcessCpBand(void)
{

        Clprg[ChanNum].ToneTransition = 0;


        testpower( );

        if(!Clprg[ChanNum].CpAvgParams.Status) {
                ++Clprg[ChanNum].ToneLowCnt;// >= Cp_5secs) Clprg[ChanNum].MinIpLvl = LVL_43dBm;
                if (!Clprg[ChanNum].ToneHiCnt) return;
                Clprg[ChanNum].ToneOnTime = Clprg[ChanNum].ToneHiCnt;
                Clprg[ChanNum].ToneHiCnt = 0;
                Clprg[ChanNum].ToneTransition = 1;
        }
        else {
                if (++Clprg[ChanNum].ToneHiCnt == Cp_40ms)
                        //Clprg[ChanNum].MinIpLvl = ptVFD->IpParams.AverageInputLevel >> 1;
                    //fprintf(CLPMLEV,"%d\n",Clprg[ChanNum].MinIpLvl);
                if(!Clprg[ChanNum].ToneLowCnt)return;
                Clprg[ChanNum].ToneOffTime = Clprg[ChanNum].ToneLowCnt;
                Clprg[ChanNum].ToneLowCnt = 0;
                Clprg[ChanNum].ToneTransition = 2;
        }
        Clprg[ChanNum].DefaultCntr = 0;
}
void CpReceiver()
{

        //ProcessCpBand(ptVFD);
        ProcessCpBand();
        Supervise();
}


void testpower( void)
{
    Clprg[ChanNum].CpAvgParams.Status= 0;

        if (Clprg[ChanNum].resultpower < Threshold)
             Clprg[ChanNum].CpAvgParams.Status= 0;
        else
         Clprg[ChanNum].CpAvgParams.Status= 1;
}
/*************************************************************************
** DESCRIPTION  :
**      This function is is used to monitor the different
**       callprogress tones
**
**      1.  In monitors the dial tone initially.If the ToneOntime is
**          greater than 1000ms it sends the message indicating the
**          detection of DIAL TONE.
**
**      2.  It also monitors for the detection of RINGBACK and BUSY
**          tones through a function call Rb_B_tests.
**
**      3.  It also monitors for the detection of 2100Hz ANSWER tone
**          through a function call Detect2100
*************************************************************************/


void Supervise(void)
{
        Word16 TypeofTone;
        if (Clprg[ChanNum].DetectDialTone)
        {
            if (Clprg[ChanNum].ToneHiCnt < Cp_1000ms) return;
                //SetIdleReceiver();
        //      Clprg.ModemMode &= ~CALLPROGRESS;
                //Debug1(CLPRG_DETECT_DIALTONE);
//              SendMessage(mGOTDIALTONE);
                //dialtontcount[ChanNum]=0;
                TypeofTone = 1;
                dspipcToneIndication(ChanNum,TypeofTone);
                                Clprg[ChanNum].DetectDialTone = 0;
                FlagDetectDialTone[ChanNum] = 0;
                confSetToneDetect(ChanNum,0);

                Clprg[ChanNum].DetectDialTone = 0;

                return;

        }
//      Rb_B_Tests();
}
#define NoBusy { Clprg[ChanNum].BusyToneCnt = Clprg[ChanNum].PrevOnTime =       Clprg[ChanNum].PrevOffTime = 0; }
void Rb_B_Tests(void) {
        Word16 Bs = 0;
        Word16 TypeofTone;

        if (!Clprg[ChanNum].ToneTransition)
                return;
        if (Clprg[ChanNum].ToneOffTime < Cp_50ms) return;
        if (Clprg[ChanNum].ToneOnTime < Cp_50ms) return;

        Clprg[ChanNum].ToneDurDiff = Abs(Clprg[ChanNum].ToneOnTime -Clprg[ChanNum].ToneOffTime);

        while(1 && (Clprg[ChanNum].DetectBusyTone&2)) {
        //if(!Clprg.DetectBusyTone)) {
                if (Clprg[ChanNum].ToneOnTime < Cp_900ms) break;
                if (Clprg[ChanNum].ToneOnTime > Cp_2140ms) break; //2140
                if (Clprg[ChanNum].ToneOffTime < Cp_1260ms) break;  //1260     // 70 % of Off time
                if (RoundM(Clprg[ChanNum].ToneOffTime,0x4B4B) <
                        Clprg[ChanNum].ToneOnTime) break;
                Clprg[ChanNum].BusyToneCnt = 0;
                if (Clprg[ChanNum].ToneTransition == 1) break;
                //printf("\nRING BACK TONE DETECTED");
                TypeofTone = 3;
                dspipcToneIndication(ChanNum,TypeofTone);
                FlagDetectBusyTone[ChanNum] = 0;
                Clprg[ChanNum].DetectBusyTone = 0;
                confSetToneDetect(ChanNum,0);
                break;
        }

        if (!(Clprg[ChanNum].DetectBusyTone&1)) return;
        if ( (Clprg[ChanNum].ToneOffTime * 3) < Clprg[ChanNum].ToneOnTime) Bs = 5;
        else {
                if (Clprg[ChanNum].ToneDurDiff < BUSY_TOLERENCE) Bs = 6;
                else Bs = 1;
        }
        switch (Bs) {
                case 0:
                        NoBusy;
                        return;

                case 6:
                        if (Clprg[ChanNum].ToneOnTime > MAXBUSYTIME)
                        {
                                NoBusy;
                                return;
                        }

                case 5:
                        if (Clprg[ChanNum].PrevOnTime && Clprg[ChanNum].PrevOffTime) {
                                if (Abs(Clprg[ChanNum].ToneOffTime-Clprg[ChanNum].PrevOffTime)
                                        > BUSY_TOLERENCE) {
                                        NoBusy;
                                        return;
                                }
                                if (Abs(Clprg[ChanNum].ToneOnTime-Clprg[ChanNum].PrevOnTime)
                                        > BUSY_TOLERENCE) {
                                        NoBusy;
                                        return;
                                }
                        }

                default:
                        Clprg[ChanNum].PrevOnTime = Clprg[ChanNum].ToneOnTime;
                        Clprg[ChanNum].PrevOffTime = Clprg[ChanNum].ToneOffTime;

                        if (++Clprg[ChanNum].BusyToneCnt < 4) return;
                         TypeofTone = 2;
                        dspipcToneIndication(ChanNum,TypeofTone);
                        FlagDetectBusyTone[ChanNum] = 0;
                        Clprg[ChanNum].DetectBusyTone = 0;
                        confSetToneDetect(ChanNum,0);
                        //SetIdleReceiver();
                        Clprg[ChanNum].CallProgInfo |= CPBUSY;

        }
}


#endif
