#!/bin/bash

THE_CURDIR=`/bin/pwd`
THE_SRCDIR=${THE_CURDIR}/rg/os/linux-2.6
THE_BLDDIR=${THE_CURDIR}/rg/os/a-linux-2.6
THE_DSPVOICE_MOD=${THE_CURDIR}/voice/ipvoice

mkdir -p ${THE_BLDDIR}/include/linux
mkdir -p ${THE_BLDDIR}/usr
mkdir -p ${THE_BLDDIR}/kernel
ln -sfn ${THE_SRCDIR}/.config                  ${THE_BLDDIR}/.config 
ln -sfn ${THE_SRCDIR}/include/linux/autoconf.h ${THE_BLDDIR}/include/linux/autoconf.h
ln -sfn ${THE_SRCDIR}/include/linux/compile.h  ${THE_BLDDIR}/include/linux/compile.h
ln -sfn ${THE_SRCDIR}/drivers/usb/core/hcd.h   ${THE_BLDDIR}/drivers/usb/core/hcd.h
ln -sfn ${THE_SRCDIR}/drivers/usb/core/hub.h   ${THE_BLDDIR}/drivers/usb/core/hub.h
ln -sfn ${THE_SRCDIR}/kernel/config.bin        ${THE_BLDDIR}/kernel/config.bin 
ln -sfn ${THE_SRCDIR}/usr/initramfs_data.bin   ${THE_BLDDIR}/usr/initramfs_data.bin
ln -sfn ${THE_SRCDIR}/usr/mainfs.bin           ${THE_BLDDIR}/usr/mainfs.bin

( cd ${THE_BLDDIR} ; make -C  ${THE_SRCDIR} O=${THE_BLDDIR} )
( cd ${THE_DSPVOICE_MOD} ; make )

