/**
 * @note Copyright (c) 2006  Sagem Communication All rights reserved
 *
 * @file sbi_defs.h
 * @version 1.0
 * @date 25/11/2006
 * @author Sagem Communication
 * @brief 
**/
#ifndef _SBI_IOCTL_H_
#define _SBI_IOCTL_H_

#include <asm/ioctl.h>
#define READ_SBI   _IOWR(0x10, 0,int) /* SBI read Data Mode.       */
#define READ_INT   _IOWR(0x10, 1,int) /* INT read Data Mode.       */
#define SBI_DEVICE  "/dev/sbi"

/* SBI Major Number */
#define SBI_MAJOR 233 
/* SBI Minor Number */
#define SBI_MINOR 73 

int sbi_driver_init(void);
void sbi_driver_exit(void);

#endif
